'use strict';
var emailManager = require('../services/emailManagerService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_email_template': {
     return [
        body('name', 'Name is required.').not().isEmpty(),
        body('subject', 'Subject is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');
exports.get_email_template = function(req, res){
  emailManager.get_email_template(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.get_email_actions = function(req, res){
  emailManager.get_email_actions(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.add_email_template = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  emailManager.add_email_template(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.email_template_list = function(req, res){
  emailManager.email_template_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_email_template = function(req, res){
  emailManager.update_email_template(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_email_template = function(req, res){
  emailManager.delete_email_template(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.get_options_by_action = function(req, res){
  emailManager.get_options_by_action(req.headers.authorization,req.body.action,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};
