'use strict';
var staffSales = require('../services/staffSalesService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'addstaffSales': {
     return [
        body('waiter_key_number', 'waiter_key_number is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.addStaffSales = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  staffSales.addStaffSales(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.listStaffSales = function(req, res){
  staffSales.listStaffSales(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.getStaffSales = function(req, res){
  staffSales.getStaffSales(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.updateStaffSales = function(req, res){
  staffSales.updateStaffSales(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.deleteStaffSales = function(req, res){
  staffSales.deleteStaffSales(req.headers.authorization,req.query.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};