'use strict';
var waiter = require('../services/waiterService.js');
const { body } = require('express-validator')

exports.validate = (method) => {
  switch (method) {
    case 'add_waiter': {
     return [
        body('waiter_name', 'Name is required.').not().isEmpty(),
       ]
    }
  }
}

const { validationResult } = require('express-validator');

exports.add_waiter = function(req, res){
  const errors = validationResult(req);
  if (!errors.isEmpty()){
    res.status(422).json({ errors: errors.array() });
    return;
  }
  waiter.add_waiter(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.waiter_list = function(req, res){
  waiter.waiter_list(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.update_waiter = function(req, res){
  waiter.update_waiter(req.headers.authorization,req.body,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};

exports.delete_waiter = function(req, res){
  waiter.delete_waiter(req.headers.authorization,req.body.id,function(err, result){
    if (err)
      res.send(err);
      res.json(result);
  });
};