'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var logsFile = require('./logsModel.js');
var fileUpload = require('express-fileupload'); 
const saltRounds = 10;
var passwordHash;
var cashDetail = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add cashDetail function
cashDetail.addCashDetail = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query('INSERT INTO cash_details (user_id,unit,description,is_deleted,created_at,updated_at) VALUES ("'+body.user_id+'","'+body.unit+'","'+body.description+'",0,"'+createdDate+'","'+createdDate+'")',function(errs,res){
                    if(!errs){        
                        var logsData={added_by:body.user_id,type:'add_cash_detail',message:'Cash detail ('+body.description+') has been added',json_data:JSON.stringify({id:res.insertId,type:'cash_detail'})}  
                        logsFile.addLogs(authorization,logsData);
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the cash detail',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//cashDetail list function
cashDetail.listCashDetails = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.user_id)
                    search="user_id = '"+body.user_id+"' AND "
                if(body.unit)
                    search+="unit LIKE '%"+body.unit.trim()+"%' AND "
                if(body.description)
                    search+="description LIKE '%"+body.description.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                //console.log(body.user_id);

                sql.query("SELECT * from cash_details WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all the cash details',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Get cashDetail function
cashDetail.getCashDetail = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from cash_details WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'Cash detail not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update cashDetail function
cashDetail.updateCashDetail = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {            
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                sql.query('UPDATE cash_details SET unit="'+body.unit+'", description="'+body.description+'",updated_at="'+createdDate+'" WHERE id="'+body.id+'"',function(errs,res){
                    if(!errs){    
                        var logsData={added_by:body.user_id,type:'update_cash_detail',message:'Cash detail ('+body.description+') has been updated',json_data:JSON.stringify({id:body.id,type:'cash_detail'})}  
                        logsFile.addLogs(authorization,logsData);
                        response = {
                            'status':'success',
                            'message':'Successfully updated the cash detail',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete cashDetail function
cashDetail.deleteCashDetail = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            var today = new Date();
            var datetime = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate()+' '+today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
            if(!err){
                sql.query("UPDATE cash_details SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){    
                        sql.query("SELECT * from cash_details WHERE is_deleted=1 AND id='"+id+"'",function(errss,body){
                            var logsData={added_by:body[0].user_id,type:'delete_cash_detail',message:'Cash detail ('+body[0].description+') has been deleted',json_data:JSON.stringify({id:body[0].id,type:'cash_detail'})}  
                            logsFile.addLogs(authorization,logsData);
                        });
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the cash detail',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= cashDetail;