'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
var jwt = require('jsonwebtoken');
var emailManager = function(use){

};


//Get email template function
emailManager.get_email_template = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from email_templates WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get email actions function
emailManager.get_email_actions = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from email_actions ",function(errs,res){
                    if(!errs){
                        if(res){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get email actions function
emailManager.get_options_by_action = async function(authorization,action) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                //console.log("SELECT options from email_actions WHERE action='"+action+"'")
                sql.query("SELECT options from email_actions WHERE action='"+action+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired', 
                }
                resolve(response)
            }            
        }); 
    });
} 

//Add email_template function
emailManager.add_email_template = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("INSERT INTO email_templates (name,subject,action,body,created_at,updated_at) VALUES ('"+body.name+"','"+body.subject+"','"+body.action+"','"+body.body+"','"+createdDate+"','"+createdDate+"')",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the Email Template',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//email_template list function
emailManager.email_template_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.name)
                    search="name LIKE '%"+body.name.trim()+"%' AND "
                if(body.subject)
                    search+="subject LIKE '%"+body.subject.trim()+"%' AND "

                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }

                //console.log("SELECT * from email_templates WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort)

                sql.query("SELECT * from email_templates WHERE "+search+" is_deleted='0' order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all Email Templates',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Update email_template function
emailManager.update_email_template = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            var today = new Date();
            var datetime = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate()+' '+today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("UPDATE email_templates SET name='"+body.name+"', subject='"+body.subject+"', action='"+body.action+"', body='"+body.body+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully updated the Email Template',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete email_template function
emailManager.delete_email_template = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            var today = new Date();
            var datetime = today.getFullYear()+'-'+(today.getMonth()+1)+'-'+today.getDate()+' '+today.getHours() + ":" + today.getMinutes() + ":" + today.getSeconds();
            if(!err){
                sql.query("UPDATE email_templates SET is_deleted='1' WHERE id='"+id+"'",function(errs,res){
                    if(!errs){    
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the Email Template',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= emailManager;