'user strict';
var sql = require('./../../conf/db.js');
var config = require('./../../conf/config.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var Request = require("request");
var moment = require('moment');
moment.suppressDeprecationWarnings = true;

var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload'); 
const saltRounds = 10;
var login = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

async function  randomNumber(){

  var random_id  = Math.floor(Math.random() * 9000);

  var partner =  checkRandomPartnerID(random_id);

  if(partner.status == false){
    randomNumber()

} else{

  return random_id;

}
}

async function  checkRandomPartnerID(number){

    return new Promise((resolve) => {

        sql.query("SELECT * from user_details WHERE partner_id='"+number+"'",function(err,res){
            if(!err){
                if(res.length <= 0){   
                    response = {
                        'status':true
                    }
                    resolve(response)
                }else{
                    response = {
                        'status':false
                    }
                    resolve(response)
                }
            }else{
                response = {
                    'status':false
                }
                resolve(response)
            }            
        }); 
    });
}

//register function
login.register = async function(body) {
    return new Promise((resolve) => {
        res = {
            'status':'success',
            'message':'Please select a Plan.'
        }
        resolve(res)
    });
}

login.newRegister = async function(body) {
    var password = await generatePassword(body.password);

    
    
    if(body.role_id  == 2 ){
        var partner_id = await randomNumber();
        var final_partner_id = partner_id;
    }else{
       var final_partner_id = null;
   }

   return new Promise((resolve) => {

    var e = body.email == null ? null : "'"+body.email+"'";
    var new_partner_id = final_partner_id == null ? null : "'"+final_partner_id+"'";

    sql.query("INSERT INTO users (first_name,last_name,phone_number,email,password,user_role_id) VALUES ('"+body.first_name+"','"+body.last_name+"','"+body.mobile_number+"',"+e+",'"+ password+"','"+ body.role_id+"')",function(err,res1){
        if(!err){
            sql.query("INSERT INTO user_addresses (address,city,country,state,latitude,longitude,zip_code,user_id) VALUES ('"+body.address+"','"+body.city+"','"+body.country+"','"+body.state+"','"+ body.latitude+"','"+body.longitude+"','"+ body.zip_code+"','"+ res1.insertId+"')",function(err,res){
                if(!err){

                    sql.query("INSERT INTO user_details (user_id,partner_id) VALUES ('"+res1.insertId+"',"+new_partner_id+")",function(err,res){
                        if(!err){
                            response = {
                                'status':'success',
                                'message':'Successfully inserted.',
                            }
                            resolve(response);
                        }else{
                            response = {
                                'status':'error',
                                'message':'Error in query.',
                                'data':err
                            }
                            resolve(response)
                        }            
                    });

                } else{
                    response = {
                        'status':'error',
                        'message':'Error in query.',
                        'data':err
                    }
                    resolve(response)
                }            
            }); 
        }
        else{
            response = {
                'status':'error',
                'message':'Error in query.',
                'data':err
            }
            resolve(response)
        }            
    }); 
});
}



login.sign_match_otp = async function(body) {
    var OTP  =  body.otp;
    var mobile_number  =  body.mobile_number;
    //const validateString = await generatePassword(body.mobile_number);
    return new Promise((resolve) => {

        sql.query("SELECT * FROM users WHERE phone_number='"+mobile_number+"' AND login_otp = '"+OTP+"'",function(err,res){
            if(!err){
                if(res[0]){
                    var current_time  = userDefinedFunction.databaseFormat();
                    current_time  = moment(new Date(current_time)).format('YYYY-MM-DD h:mm:ss');

                    var sent_OTP_time = res[0].login_otp_expiry_time;
                    sent_OTP_time  = moment(new Date(sent_OTP_time)).format('YYYY-MM-DD h:mm:ss');

                    var added_send_date = moment(sent_OTP_time).add(5, 'm').toDate();

                    added_send_date  = moment(new Date(added_send_date)).format('YYYY-MM-DD h:mm:ss');

                    if(current_time >  added_send_date){
                        res = {
                            'status':'error',
                            'message':'Your OTP has been expired.Plese resend.'
                        }
                        resolve(res);
                    }else{
                        var token=jwt.sign({data: res[0].email,user_id: res[0].id}, 'secret', { expiresIn: '1d' });
                        //console.log(mobile_number)
                        sql.query("UPDATE users SET is_verified = 1 WHERE phone_number='"+mobile_number+"'",function(err,res){})
                        res = {
                            'status':'success',
                            'token':token,
                            'message':'OTP successfully matched.'
                        }
                        resolve(res)
                    }
                }else {
                    res = {
                        'status':'error',
                        'message':'Incorrect OTP.'
                    }
                }
            }else{
                res = {
                    'status': 'error',
                    data: err,
                }
            }   
            resolve(res)
        }); 
    });
}

//login function

login.signin = async function(email,body) {

    var OTP  = Math.floor(Math.random() * 90000) +10000;

    var login_otp_expiry_time  = userDefinedFunction.databaseFormat();

    return new Promise((resolve) => {

        if(body.role_id && body.role_id == 2 ){
            var role_id = body.role_id;
        }else{
            var role_id = body.role_id;
        }

        /* sql.query("SELECT * from users WHERE email='"+email+"' OR phone_number= '"+email+"'",function(err,res){*/
           sql.query("SELECT * from users WHERE phone_number= '"+email+"' && user_role_id= '"+role_id+"'",function(err,res){
            if(!err){
                if(res[0]){    
                    //var token=jwt.sign({data: res[0].email,user_id: res[0].id}, 'secret', { expiresIn: '1d' });
                    //const matchpassword = await checkPassword(password,res[0].password);
                    bcrypt.compare(body.password, res[0].password, function(errs, ress) {

                        if(!errs){  

                            if(ress==true){

                                var user= sql.query("SELECT * from users WHERE  phone_number= '"+email+"'",function(er,re){/*sql.query("SELECT * from users WHERE email='"+email+"' OR phone_number= '"+email+"'",function(er,re){*/
                                    if(re[0].is_verified == 1 && re[0].is_active == 1 && re[0].is_deleted == 0 ){
                                        sql.query("UPDATE user_details SET language='"+body.language+"' WHERE user_id='"+re[0].id+"'",function(err,res){})
                                        //sql.query("UPDATE users SET login_otp='"+OTP+"', login_otp_expiry_time='"+login_otp_expiry_time+"' WHERE email='"+email+"' OR phone_number='"+email+"'",function(err,res){})
                                        var token=jwt.sign({data: res[0].email,user_id: res[0].id}, 'secret', { expiresIn: '1d' });
                                        response = {
                                            'status':'success',
                                            'token':token,
                                            'message':'successfully login.',
                                        }
                                        resolve(response)
                                    }
                                    if(re[0].is_verified != 1){

                                        Request.get("http://sms.smsmenow.in/sendsms.jsp?user=msfinc&password=eb5931de85XX&senderid=MSFINC&mobiles="+email+"&sms=Dear+customer,+your+OTP+is "+OTP, (error, response, body) => {
                                            if(error) {
                                               response = {
                                                'status':'error',
                                                'message':'Sorry!! Currently we are unable to send OTP. Please try again.',
                                            }
                                            resolve(response)

                                        }
                                    });
                                        sql.query("UPDATE user_details SET language='"+body.language+"' WHERE user_id='"+re[0].id+"'",function(err,res){})
                                        sql.query("UPDATE users SET login_otp='"+OTP+"', login_otp_expiry_time='"+login_otp_expiry_time+"' WHERE email='"+email+"' OR phone_number='"+email+"'",function(err,res){})
                                        response = {
                                            'status':'error',
                                            'message':'user is not verified yet.',
                                        }
                                        resolve(response)
                                    }
                                    if(re[0].is_active != 1){
                                        response = {
                                            'status':'error',
                                            'message':'user is not active.',
                                        }
                                        resolve(response)
                                    }
                                    if(re[0].is_deleted != 0){
                                        response = {
                                            'status':'error',
                                            'message':'user is deleted.',
                                        }
                                        resolve(response)
                                    }
                                })
                                //if()
                                /*
                                    space for sennding OTP onMobile

                                    */

                                }
                                else{
                                    response = {
                                        'status':'fail',
                                        'message':'Email and password didnt match.',
                                        data:ress
                                    }
                                    resolve(response)
                                }
                            }
                            else{
                                response = {
                                    'status':'error',
                                    'status':'Error in password matching.',
                                    data:errs
                                }
                                resolve(response)
                            }
                           // resolve(response)

                       }); 

}else{
    response = {
        'status':'not found',
        'message':'No user found.',
        'data':null
    }
    resolve(response)
}
}
else{
    response = {
        'status':'error',
        'message':'Error in query.',
        'data':err
    }
    resolve(response)
}            
}); 
});
} 

//Admin login function
login.admin_signin = async function(email,password) {
    return new Promise((resolve) => {
        sql.query("SELECT * from users WHERE email='"+email+"'",function(err,res){
            if(!err){
                if(res[0]){     
                    var token=jwt.sign({data: res[0].email}, 'secret', { expiresIn: '1d' });
                    //const matchpassword = await checkPassword(password,res[0].password);
                    bcrypt.compare(password, res[0].password, function(errs, ress) {
                        if(!errs){                    
                            if(ress==true){
                                var adminRoleId=userDefinedFunction.SUPER_ADMIN_ROLE_ID();
                                var subAdminRoleId=userDefinedFunction.SUB_ADMIN_ROLE_ID();
                                if(res[0].user_role_id==adminRoleId || res[0].user_role_id==subAdminRoleId  ){
                                    response = {
                                        'status':'success',
                                        'message':'successfully login.',
                                        data:res[0],
                                        'token':token
                                    }
                                }
                                else{
                                    response = {
                                        'status':'access denied',
                                        'message':'Access Denied.',
                                    }
                                }    
                            }
                            else{
                                response = {
                                    'status':'fail',
                                    'message':'Email and password didnt match.',
                                    data:ress
                                }
                            }
                        }
                        else{
                            response = {
                                'status':'error',
                                'status':'Error in password matching.',
                                data:errs
                            }
                        }
                        resolve(response)

                    }); 

                }else{
                    response = {
                        'status':'not found',
                        'message':'No user found.',
                        'data':null
                    }
                    resolve(response)
                }
            }
            else{
                response = {
                    'status':'error',
                    'message':'Error in query.',
                    'data':err
                }
                resolve(response)
            }            
        }); 
    });
} 

login.send_otp = async function(body) {

    var OTP  = Math.floor(Math.random() * 90000)+10000;
    //var OTP  = 12345;
    var login_otp_expiry_time  = userDefinedFunction.databaseFormat();

    return new Promise((resolve) => {

        var mobile_number = body.mobile_number;

        sql.query("SELECT * FROM users WHERE phone_number='"+mobile_number+"'",function(err,res){
            if(res[0]){

                Request.get("http://sms.smsmenow.in/sendsms.jsp?user=msfinc&password=eb5931de85XX&senderid=MSFINC&mobiles="+mobile_number+"&sms=Dear+customer,+your+OTP+is "+OTP, (error, response, body) => {
                    if(error) {
                       response = {
                        'status':'error',
                        'message':'Sorry!! Currently we are unable to send OTP. Please try again.',
                    }
                    resolve(response)

                }
            });
                sql.query("UPDATE users SET login_otp='"+OTP+"', login_otp_expiry_time='"+login_otp_expiry_time+"' WHERE phone_number='"+mobile_number+"'",function(err,res){})
                res = {
                    'status':'success',
                    'message':'OTP successfully sent to your Mobile. Please check.'
                }
            }else {
                res = {
                    'status':'error',
                    'message':'No user found.'
                }
            }
            resolve(res)
        }); 
    });
}
login.match_otp = async function(body) {
    var OTP  =  body.otp;
    var mobile_number  =  body.mobile_number;
    const validateString = await generatePassword(body.mobile_number);
    return new Promise((resolve) => {
        sql.query("SELECT * FROM users WHERE phone_number='"+mobile_number+"' AND login_otp = '"+OTP+"'",function(err,res){
            if(!err){
                if(res[0]){
                    var current_time  = userDefinedFunction.databaseFormat();
                    current_time  = moment(new Date(current_time)).format('YYYY-MM-DD h:mm:ss');

                    var sent_OTP_time = res[0].login_otp_expiry_time;
                    sent_OTP_time  = moment(new Date(sent_OTP_time)).format('YYYY-MM-DD h:mm:ss');

                    var added_send_date = moment(sent_OTP_time).add(5, 'm').toDate();
                    added_send_date  = moment(new Date(added_send_date)).format('YYYY-MM-DD h:mm:ss');

                    if(current_time >  added_send_date){
                        res = {
                            'status':'error',
                            'message':'Your OTP has been expired.Plese resend.'
                        }
                        resolve(res);
                    }else{
                        sql.query("UPDATE users SET is_verified = 1, validate_string='"+validateString+"' , forgot_password_validate_string='"+validateString+"' WHERE phone_number='"+mobile_number+"'",function(err,res){})
                        res = {
                            'status':'success',
                            data:validateString,
                            'message':'OTP successfully matched.'
                        }
                        resolve(res)
                    }
                }else {
                    res = {
                        'status':'error',
                        'message':'Incorrect OTP.'
                    }
                }
            }else{
                res = {
                    'status': 'error',
                    data: err,
                }
            }   
            resolve(res)
        }); 
    });
}

//forgotPassword function
login.forgotPassword = async function(body) {
    const validateString = await generatePassword(body.email);
    return new Promise((resolve) => {
        var verifyLink  = body.host+'/reset-password/'+validateString;
        verifyURL       = '<a href="'+verifyLink+'">Click Here to reset your password</a>';
        //var fullName = body.name;
        var email = body.email;
        sql.query("SELECT * FROM users WHERE email='"+email+"'",function(err,res){
            if(res[0]){
                var port=body.host.split(':')[2];
                var adminRoleId=userDefinedFunction.SUPER_ADMIN_ROLE_ID();
                if(res[0].user_role_id==adminRoleId && port=='4202'){
                    res = {
                        'status':'permission denied',
                        'message':'Permission denied'
                    }
                }
                else if(res[0].user_role_id!=adminRoleId && port=='4203'){
                    res = {
                        'status':'permission denied',
                        'message':'Permission denied'
                    }
                }
                else{
                    sql.query("UPDATE users SET validate_string='"+validateString+"', forgot_password_validate_string='"+validateString+"' WHERE email='"+email+"'",function(err,res){})
                    repArray = [res[0].full_name,verifyURL,verifyLink];
                    userDefinedFunction.sendMail(email,repArray,'reset_password');
                    res = {
                        'status':'success',
                        'message':'Reset password link successfully sent to your email. Please check.'
                    }
                }
            }else{
                res = {
                    'status':'error',
                    'message':'No user found.'
                }
            }
            resolve(res)
        }); 
    });
}

//Reset password function
login.reset_password = async function(body) {
    const newpasswordHash = await generatePassword(body.new_password);
    return new Promise((resolve) => {
        //console.log(body.verify_string)
        sql.query("SELECT * FROM users WHERE forgot_password_validate_string='"+body.verify_string+"' AND validate_string !=''",function(err,res){
         if(!err){
            if(res.length == 0){
                response = {
                    'status':'error',
                    'message':'Reset password failed.',
                }
                resolve(response)
            }else{
                sql.query("UPDATE users SET  password='"+newpasswordHash+"' , validate_string='' WHERE forgot_password_validate_string='"+body.verify_string+"'",function(err,res){
                    if(!err){
                        if(res){   
                            response = {
                                'status':'success',
                                'message':'Successfully reset the passwod.',
                            }
                            resolve(response)
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found.',
                            } 
                            resolve(response)                                       
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            data: err,
                        }
                    }   
                    resolve(response)
                });      
            }
        } else{
            response = {
                'status': 'error',
                data: err,
            }
            resolve(response)             
        }   
    });
    }); 
} 

login.checkValidMobileNumber = async function(mobile_number) {
    if(mobile_number == ""){
        response = {
            'status':false
        }
        resolve(response)
    }
    return new Promise((resolve) => {
        sql.query("SELECT id from users WHERE phone_number='"+mobile_number+"'",function(err,res){
            if(!err){
                if(res.length > 0){   
                    response = {
                        'status':false
                    }
                    resolve(response)
                }else{
                    response = {
                        'status':true
                    }
                    resolve(response)
                }
            }else{
                response = {
                    'status':true
                }
                resolve(response)
            }            
        }); 
    });
}

login.checkValidEmail = async function(email) {
    if(email == ""){
        response = {
            'status':false
        }
        resolve(response)
    }
    return new Promise((resolve) => {
        sql.query("SELECT id from users WHERE email='"+email+"'",function(err,res){
            if(!err){
                if(res.length > 0){   
                    response = {
                        'status':false
                    }
                    resolve(response)
                }else{
                    response = {
                        'status':true
                    }
                    resolve(response)
                }
            }else{
                response = {
                    'status':true
                }
                resolve(response)
            }            
        }); 
    });
}


login.logout = async function(body) {
    return new Promise((resolve) => {
        resolve("hello");
    });
}

login.checkValidValidateString = async function(validateString) {
    if(validateString == ""){
        response = {
            'status':false
        }
        resolve(response)
    }
    return new Promise((resolve) => {
        sql.query("SELECT id from users WHERE validate_string='"+validateString+"'",function(err,res){
            if(!err){
                if(res.length > 0){
                    response = {
                        'status':true
                    }
                    resolve(response)
                }else{
                    response = {
                        'status':false
                    }
                    resolve(response)
                }
            }else{
                response = {
                    'status':false
                }
                resolve(response)
            }            
        }); 
    });
}
login.accountVerification = async function(validateString) {
    return new Promise((resolve) => {
        sql.query("UPDATE users SET is_verified = 1 , validate_string='' WHERE validate_string='"+validateString+"'",function(err,res){
            //console.log(err);
            if(!err){
                response = {
                    'status':'success',
                    'message':'You can login now.'
                }
                resolve(response)
            }else{
                response = {
                    'status':'error',
                    'message':'This link is invalid.'
                }
                resolve(response)
            }            
        }); 
    });
}

module.exports= login;