'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload');
const saltRounds = 10;
var passwordHash;
var restaurant = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add restaurant function
restaurant.add_restaurant = async function(authorization,body) {
    const passwordHash = await generatePassword(body.password);
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("INSERT INTO users (full_name,user_role_id,parent_id,email,phone_number,address,password,key_number,is_verified,is_active,is_deleted,created_at,updated_at) VALUES ('"+body.restaurant_name+"','"+body.restaurant_id+"',"+body.parent_id+", '"+body.email+"','"+body.phone_number+"','"+body.address+"','"+passwordHash+"', "+body.restaurant_key_number+",'1','1','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                    //console.log("INSERT INTO users (full_name,user_role_id,parent_id,email,phone_number,address,password,key_number,is_verified,is_active,is_deleted,created_at,updated_at) VALUES ('"+body.restaurant_name+"','"+body.restaurant_id+"',"+body.parent_id+", '"+body.email+"','"+body.phone_number+"','"+body.address+"','"+passwordHash+"', "+body.restaurant_key_number+",'1','1','0','"+createdDate+"','"+createdDate+"')")
                    //console.log(errs)
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully inserted the restaurant',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//restaurant list function
restaurant.restaurant_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                var created_at = userDefinedFunction.formatDate(body.created_at);
                var updated_at = userDefinedFunction.formatDate(body.updated_at);
                if(body.created_at && !body.updated_at)
                    search+="created_at BETWEEN '"+created_at+"' AND '"+created_at+"' AND "
                if(body.updated_at && !body.created_at)
                    search+="created_at BETWEEN '"+updated_at+"' AND '"+updated_at+"' AND "
                if(body.updated_at && body.created_at)
                    search+="created_at BETWEEN '"+created_at+"' AND '"+updated_at+"' AND "
                if(body.restaurant_name)
                    search+="full_name LIKE '%"+body.restaurant_name.trim()+"%' AND "
                if(body.email)
                    search+="email LIKE '%"+body.email.trim()+"%' AND "
                if(body.id)
                    search+="id LIKE '%"+body.id.trim()+"%' AND "

                //console.log(search)
                
                if(body.orderBy=='id')
                    body.orderBy='id'
                if(body.orderBy=='restaurant_key_number')
                    body.orderBy='key_number'
                if(body.orderBy=='restaurant_name')
                    body.orderBy='full_name'
                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }

                //console.log("SELECT *,DATE_FORMAT(created_at,'%d/%m/%Y %h:%i %p') as created_at from users WHERE "+search+" is_deleted='0' AND user_role_id="+2+" order by "+body.orderBy+" "+body.sort)
                var restaurantRoleId=userDefinedFunction.RESTAURANT_ROLE_ID();
                sql.query("SELECT * from users WHERE "+search+" is_deleted='0' AND user_role_id="+restaurantRoleId+" order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all restaurant',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Get restaurant function
restaurant.getRestaurant = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT * from users WHERE id="+id,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully get the restaurant',
                            data:res[0],
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update restaurant function
restaurant.update_restaurant = async function(authorization,body) {
    if(body.password){
        passwordHash = await generatePassword(body.password);
    }
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                var update_pass="";
                if(passwordHash){
                    update_pass="password='"+passwordHash+"',";
                }
                sql.query("UPDATE users SET full_name='"+body.restaurant_name+"', parent_id='"+body.parent_id+"', address='"+body.address+"', "+update_pass+" key_number='"+body.restaurant_key_number+"', email='"+body.email+"',phone_number='"+body.phone_number+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully updated the restaurant',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete restaurant function
restaurant.delete_restaurant = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("UPDATE users SET is_deleted='1' WHERE id="+id+"",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the restaurant',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Toggle restaurant status function
restaurant.toggleRestaurantStatus = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("SELECT is_active FROM users WHERE id="+id+"",function(errs,res){
                    var message,type,query;
                    if(res[0].is_active==1){
                        query="UPDATE users SET is_active='0' WHERE id="+id+"";
                        message='Successfully deactivated the Restaurant status';
                        type='deactive'
                    }
                    else{
                        query="UPDATE users SET is_active='1' WHERE id="+id+""
                        message='Successfully activated the Restaurant status';
                        type='active'
                    }

                    sql.query(query,function(errs,ress){
                        if(!errs){   
                            response = {
                                'status':'success',
                                'message':message,
                                type:type,
                            }
                        }
                        else{
                            response = {
                                'status': 'error',
                                'message': errs,
                            }
                        }
                        resolve(response)
                    });
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= restaurant;