'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
var fileUpload = require('express-fileupload');
const saltRounds = 10;
var passwordHash;
var subAdmin = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

//Add staff function
subAdmin.add_sub_admin = async function(authorization,body) {
    const passwordHash = await generatePassword(body.password);
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("SELECT * FROM users WHERE email='"+body.email+"' AND user_role_id='"+body.user_role_id+"' AND is_deleted='0'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Sub Admin already exist',
                        }
                        resolve(response)
                    }
                    else{
                        if(!body.staff_key_number)
                            body.staff_key_number=null;
                            
                        sql.query("INSERT INTO users (full_name,user_role_id,parent_id,email,phone_number,password,is_verified,is_active,is_deleted,created_at,updated_at) VALUES ('"+body.name+"','"+body.user_role_id+"',"+body.parent_id+", '"+body.email+"','"+body.phone_number+"','"+passwordHash+"', '1','1','0','"+createdDate+"','"+createdDate+"')",function(errs,res){
                        //console.log("INSERT INTO users (full_name,user_role_id,parent_id,email,phone_number,address,password,key_number,is_verified,is_active,is_deleted,created_at,updated_at) VALUES ('"+body.name+"','"+body.user_role_id+"',"+body.parent_id+", '"+body.email+"','"+body.phone_number+"','"+body.address+"','"+passwordHash+"', "+body.staff_key_number+",'1','1','0','"+createdDate+"','"+createdDate+"')")
                        //console.log(errs)
                            if(!errs){   
                                response = {
                                    'status':'success',
                                    'message':'Successfully inserted the Sub Admin',
                                }
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': errs,
                                }
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Staff list function
subAdmin.sub_admin_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var search='1 AND ';
                if(body.parent_id)
                    search="parent_id = '"+body.parent_id+"' AND "
                if(body.name)
                    search+="full_name LIKE '%"+body.name.trim()+"%' AND "
                if(body.email)
                    search+="email LIKE '%"+body.email.trim()+"%' AND "
                if(body.phone_number)
                    search+="phone_number LIKE '%"+body.phone_number.trim()+"%' AND "
                if(body.logged_user_id)
                    search+="id NOT IN ('"+body.logged_user_id+"') AND "                
                
                if(body.orderBy=='name')
                    body.orderBy='full_name'
                if(body.orderBy==undefined)
                {
                    body.orderBy=1
                    body.sort='desc';
                }
                //console.log(search)

                var subAdminRoleId=userDefinedFunction.SUB_ADMIN_ROLE_ID();
                //var staffRoleId=userDefinedFunction.STAFF_ROLE_ID()

                //console.log("SELECT *,DATE_FORMAT(created_at,'%Y-%m-%d %H:%i:%s') as created_at from users WHERE "+search+" is_deleted='0' AND user_role_id IN ("+restaurantRoleId+","+staffRoleId+") order by "+body.orderBy+" "+body.sort)

                sql.query("SELECT * from users WHERE "+search+" is_deleted='0' AND user_role_id IN ("+subAdminRoleId+") order by "+body.orderBy+" "+body.sort,function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully got all Sub Admins',
                            data:res,
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
            
        }); 
    });
} 

//Update staff function
subAdmin.update_sub_admin = async function(authorization,body) {
    if(body.password){
        passwordHash = await generatePassword(body.password);
    }
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            var createdDate = userDefinedFunction.databaseFormat();
            if(!err){
                var update_pass="";
                if(passwordHash){
                    update_pass="password='"+passwordHash+"',";
                }
                sql.query("SELECT * FROM users WHERE email='"+body.email+"' AND is_deleted='0' AND id!='"+body.id+"'",function(errss,ress){
                    if(ress[0]){
                        response = {
                            'status':'Exist',
                            'message':'Sub Admin already exist',
                        }
                        resolve(response)
                    }
                    else{
                //console.log(body.staff_key_number)
                        if(!body.staff_key_number)
                            body.staff_key_number=null;
                            
                        sql.query("UPDATE users SET full_name='"+body.name+"', user_role_id='"+body.user_role_id+"', parent_id='"+body.parent_id+"', "+update_pass+"  email='"+body.email+"',phone_number='"+body.phone_number+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(errs,res){
                            if(!errs){   
                                response = {
                                    'status':'success',
                                    'message':'Successfully updated the Sub Admin',
                                }
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': errs,
                                }
                            }
                            resolve(response)
                        });
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Delete staff function
subAdmin.delete_sub_admin = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log()
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                sql.query("UPDATE users SET is_deleted='1' WHERE id="+id+"",function(errs,res){
                    if(!errs){   
                        response = {
                            'status':'success',
                            'message':'Successfully deleted the Sub Admin',
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= subAdmin;