'user strict';
var sql = require('./../../conf/db.js');
var userDefinedFunction = require('../../lib/user_defined_function.js');
const bcrypt = require('bcrypt');
var jwt = require('jsonwebtoken');
const express = require('express');
var moment = require('moment');
moment.suppressDeprecationWarnings = true;
var fileUpload = require('express-fileupload');
const app = express();
//app.use(fileUpload());
const saltRounds = 10;
var passwordHash;
var user = function(use){

};

async function  generatePassword(password){
    return new Promise((resolve) => {
        bcrypt.hash(password, saltRounds, function(err, hash) {
            resolve(hash);
        });
    });
}

user.upload_profile_pic = async function(authorization,body) {

    return new Promise((resolve) => {

        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }

        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                if (!body.files || Object.keys(body.files).length === 0) {
                    response = {
                        'status': 'error',
                        'message': 'No files were uploaded'
                    }
                    resolve(response);
                }

                var time = new Date();

                var random  = Math.floor(Math.random() * 900000);


                var profile_pic = body.files.profile_pic;
                var profile_picFileName = time.getTime()+random + body.files.profile_pic.name;

                profile_pic.mv('/var/www/html/nodeapi/uploads/'+profile_picFileName, function(err) {
                    if (err){
                      response = {
                        'status': 'error',
                        'message': "Adhar front not uploaded"
                    }
                } else {

                    var user_id  = jwt.decode(token, 'secret').user_id;

                    sql.query("UPDATE user_details SET profile_pic='"+profile_picFileName+"' WHERE user_id='"+user_id+"'",function(err,res){
                        if(!err){
                            response = {
                                'status':'success',
                                "message":"Profile picture uploaded successfully.",
                                "profile_pic":profile_picFileName
                            }
                            resolve(response);
                        }
                        else{
                            response = {
                                'status': 'error',
                                'message': err,
                            }
                        }
                        resolve(response);
                    });
                }
            });

            }else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
        });
    });
}



user.upload = async function(authorization,body) {

    return new Promise((resolve) => {

        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }

        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                if (!body.files || Object.keys(body.files).length === 0) {
                    response = {
                        'status': 'error',
                        'message': 'No files were uploaded'
                    }
                    resolve(response);
                }

                var adhar_front = body.files.adhar_front;


                if(adhar_front != '' && adhar_front != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);

                    var adhar_frontFileName = time.getTime()+random + body.files.adhar_front.name;

                    

                    adhar_front.mv('/var/www/html/nodeapi/uploads/'+adhar_frontFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Adhar front not uploaded"
                        }
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Adhar front uploaded successfully.',
                            "file_name":adhar_frontFileName
                        }
                    }
                })
                }else{

                    response={
                        "status":'error',
                        "message":"Front of adhar card is required."
                    }
                    resolve(response);
                }


                var adhar_back = body.files.adhar_back;
                if(adhar_back != '' && adhar_back != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var adhar_backFileName = time.getTime()+random + body.files.adhar_back.name;


                    adhar_back.mv('/var/www/html/nodeapi/uploads/'+adhar_backFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Driving license not uploaded"
                        }
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Adhar back uploaded successfully.',
                            "file_name":adhar_backFileName
                        }

                    }
                })
                }else{

                    response={
                        "status":'error',
                        "message":"Back of adhar card is required."
                    }
                    resolve(response);
                }


                var pan_card = body.files.pan_card;
                if(pan_card != '' && pan_card != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var pan_cardFileName = time.getTime()+random + body.files.pan_card.name;


                    pan_card.mv('/var/www/html/nodeapi/uploads/'+pan_cardFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Driving license not uploaded"
                        }
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Pan card uploaded successfully.',
                            "file_name":pan_cardFileName
                        }

                    }
                })
                }else{

                    response={
                        "status":'error',
                        "message":"Pan card is required."
                    }
                    resolve(response);
                }






                var other = body.files.other;

                if(other != '' && other != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var otherFileName = time.getTime() +random+ body.files.other.name;

                    other.mv('/var/www/html/nodeapi/uploads/'+otherFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Driving license not uploaded"
                        }
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Bank statement uploaded successfully.',
                            "file_name":otherFileName
                        }
                    }
                });
                }else {
                    var   otherFileName   = 'null';

                }




                var driving_license = body.files.driving_license;

                if(driving_license != '' && driving_license != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var driving_licenseFileName = time.getTime() +random+ body.files.driving_license.name;

                    driving_license.mv('/var/www/html/nodeapi/uploads/'+driving_licenseFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Driving license not uploaded"
                        }
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Driving license uploaded successfully.',
                            "file_name":driving_licenseFileName
                        }
                    }
                });
                }else {
                    var   driving_licenseFileName   = 'null';

                }





                var bank_statement = body.files.bank_statement;
                if(bank_statement != '' && bank_statement != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var bank_statementFileName = time.getTime() +random+ body.files.bank_statement.name;


                    bank_statement.mv('/var/www/html/nodeapi/uploads/'+bank_statementFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Bank statement not uploaded"
                        }
                    } else{

                        sql.query("INSERT INTO loan_applications_documents (aadhar_front,adhar_back,driving_licensce,bank_statement,pan_card,other_document,loan_id) VALUES ('"+adhar_frontFileName+"','"+adhar_backFileName+"','"+driving_licenseFileName+"','"+bank_statementFileName+"','"+pan_cardFileName+"','"+otherFileName+"','"+body.body.loan_id+"')",function(err,res){
                            if(!err){
                                response = {
                                    'status':'success',
                                    "message":"files uploaded successfully."
                                }
                                resolve(response);
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': err,
                                }
                            }
                            resolve(response);
                        });

                    }
                })
                }else{

                    response={
                        "status":'error',
                        "message":"Bank statement is required."
                    }
                    resolve(response);
                }


/*



                var driving_license = body.files.driving_license;

                if(driving_license != '' && driving_license != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var driving_licenseFileName = time.getTime()+random + body.files.driving_license.name;

                    driving_license.mv('/var/www/html/nodeapi/uploads/'+driving_licenseFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "files not uploaded"
                        }
                        resolve(response);
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'files uploaded successfully.',
                            "file_name":driving_licenseFileName
                        }


                        sql.query("INSERT INTO loan_applications_documents (aadhar_front,adhar_back,driving_licensce,bank_statement,pan_card,other_document,loan_id) VALUES ('"+adhar_frontFileName+"','"+adhar_backFileName+"','"+driving_licenseFileName+"','"+bank_statementFileName+"','"+pan_cardFileName+"','"+otherFileName+"','"+body.body.loan_id+"')",function(err,res){
                            if(!err){
                                response = {
                                    'status':'success',
                                    "message":"files uploaded successfully."
                                }
                                resolve(response);
                            }
                            else{
                                response = {
                                    'status': 'error',
                                    'message': err,
                                }
                            }
                            resolve(response);
                        });

                    }

                })
                }else{

                    response={
                        "status":'error',
                        "message":"Driving license is required."
                    }
                    resolve(response);
                }*/
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }

        });
});

}

async function manageLeadData(lead_id){
    return new Promise((resolve) => {


        sql.query("DELETE FROM leads_document WHERE  id='"+lead_id+"'",function(errs,res){
            if(!errs){
                response = {
                    'status':'success',
                }
            }
            else{
                response = {
                    'status': 'error',
                }
            }
            resolve(response)
        });
    })
}
user.create_lead=async function(authorization,body){

    return new Promise((resolve) => {

        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }

        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
               var user_id  = jwt.decode(token, 'secret').user_id;
               var loan_id  = 'SL'+ Math.floor(Math.random() * 900000);
               var loan_status  = 3;
               var added_by  = 0;

               var new_body  = JSON.parse(body.body.userDetails)

               var user_Details = {};
               user_Details['first_name'] = new_body.first_name
               user_Details['last_name'] = new_body.last_name
               user_Details['date_of_birth'] = new_body.date_of_birth
               user_Details['contact_number'] = new_body.contact_number
               user_Details['email'] = new_body.email
               user_Details['street'] = new_body.street
               user_Details['district'] = new_body.district
               user_Details['state'] = new_body.state
               user_Details['occupation'] = new_body.occupation
/*
               user_Details.push({'first_name': new_body.first_name});
               user_Details.push({'last_name': new_body.last_name});
               user_Details.push({'date_of_birth': new_body.date_of_birth});
               user_Details.push({'contact_number': new_body.contact_number});
               user_Details.push({'email': new_body.email});
               user_Details.push({'street': new_body.street});
               user_Details.push({'district': new_body.district});
               user_Details.push({'state': new_body.state});
               user_Details.push({'occupation': new_body.occupation});*/


               var myuser_Details = JSON.stringify(user_Details);

               sql.query("INSERT INTO leads (partner_id,user_details,loan_type,loan_amount,loan_duration,added_by,status) VALUES ('"+user_id+"','"+myuser_Details+"','"+new_body.loan_type+"','"+new_body.loan_amount+"','"+new_body.loan_duration+"','"+added_by+"','"+loan_status+"')",function(err,res){
                if(!err){

                    if (!body.files || Object.keys(body.files).length === 0) {
                        response = {
                            'status': 'error',
                            'message': 'Opps leads has not creeated. Please upload documents.'
                        }
                        resolve(response);
                    }

                    var adhar_front = body.files.adhar_front;


                    if(adhar_front != '' && adhar_front != null){
                        var time = new Date();
                        var random  = Math.floor(Math.random() * 900000);

                        var adhar_frontFileName = time.getTime()+random + body.files.adhar_front.name;



                        adhar_front.mv('/var/www/html/nodeapi/uploads/'+adhar_frontFileName, function(err) {
                            if (err){
                              response = {
                                'status': 'error',
                                'message': "Adhar front not uploaded"
                            }
                            manageLeadData(res.insertId);
                        } else{
                            response = {
                                'status': 'success',
                                'message': 'Adhar front uploaded successfully.',
                                "file_name":adhar_frontFileName
                            }
                        }
                    })
                    }else{

                        response={
                            "status":'error',
                            "message":"Front of adhar card is required."
                        }
                        manageLeadData(res.insertId);
                        resolve(response);
                    }


                    var adhar_back = body.files.adhar_back;
                    if(adhar_back != '' && adhar_back != null){
                        var time = new Date();
                        var random  = Math.floor(Math.random() * 900000);
                        var adhar_backFileName = time.getTime()+random + body.files.adhar_back.name;


                        adhar_back.mv('/var/www/html/nodeapi/uploads/'+adhar_backFileName, function(err) {
                            if (err){
                              response = {
                                'status': 'error',
                                'message': "Driving license not uploaded"
                            }
                            manageLeadData(res.insertId);
                        } else{
                            response = {
                                'status': 'success',
                                'message': 'Adhar back uploaded successfully.',
                                "file_name":adhar_backFileName
                            }

                        }
                    })
                    }else{

                        response={
                            "status":'error',
                            "message":"Back of adhar card is required."
                        }
                        manageLeadData(res.insertId);
                        resolve(response);
                    }


                    var pan_card = body.files.pan_card;
                    if(pan_card != '' && pan_card != null){
                        var time = new Date();
                        var random  = Math.floor(Math.random() * 900000);
                        var pan_cardFileName = time.getTime()+random + body.files.pan_card.name;


                        pan_card.mv('/var/www/html/nodeapi/uploads/'+pan_cardFileName, function(err) {
                            if (err){
                              response = {
                                'status': 'error',
                                'message': "Driving license not uploaded"
                            }
                            manageLeadData(res.insertId);
                        } else{
                            response = {
                                'status': 'success',
                                'message': 'Pan card uploaded successfully.',
                                "file_name":pan_cardFileName
                            }

                        }
                    })
                    }else{
                     manageLeadData(res.insertId);
                     response={
                        "status":'error',
                        "message":"Pan card is required."
                    }
                    resolve(response);
                }


                var bank_statement = body.files.bank_statement;
                if(bank_statement != '' && bank_statement != null){
                    var time = new Date();
                    var random  = Math.floor(Math.random() * 900000);
                    var bank_statementFileName = time.getTime() +random+ body.files.bank_statement.name;


                    bank_statement.mv('/var/www/html/nodeapi/uploads/'+bank_statementFileName, function(err) {
                        if (err){
                          response = {
                            'status': 'error',
                            'message': "Driving license not uploaded"
                        }
                        manageLeadData(res.insertId);
                    } else{
                        response = {
                            'status': 'success',
                            'message': 'Bank statement uploaded successfully.',
                            "file_name":bank_statementFileName
                        }

                    }
                })
                }else{
                 manageLeadData(res.insertId);
                 response={
                    "status":'error',
                    "message":"Bank statement is required."
                }
                resolve(response);
            }



            var other = body.files.other;

            if(other != '' && other != null){
                var time = new Date();
                var random  = Math.floor(Math.random() * 900000);
                var otherFileName = time.getTime() +random+ body.files.other.name;

                other.mv('/var/www/html/nodeapi/uploads/'+otherFileName, function(err) {
                    if (err){
                      response = {
                        'status': 'error',
                        'message': "Driving license not uploaded"
                    }
                    manageLeadData(res.insertId);
                } else{
                    response = {
                        'status': 'success',
                        'message': 'Bank statement uploaded successfully.',
                        "file_name":otherFileName
                    }
                }
            });
            }else {
                var   otherFileName   = 'null';

            }

            var driving_license = body.files.driving_license;
            if(driving_license != '' && driving_license != null){
                var time = new Date();
                var random  = Math.floor(Math.random() * 900000);
                var driving_licenseFileName = time.getTime()+random + body.files.driving_license.name;

                driving_license.mv('/var/www/html/nodeapi/uploads/'+driving_licenseFileName, function(err) {
                    if (err){
                      response = {
                        'status': 'error',
                        'message': "files not uploaded"
                    }
                    manageLeadData(res.insertId);
                    resolve(response);
                } else{
                    response = {
                        'status': 'success',
                        'message': 'files uploaded successfully.',
                        "file_name":driving_licenseFileName
                    }


                    sql.query("INSERT INTO leads_document (aadhar_front,adhar_back,driving_licensce,bank_statement,pan_card,other_document,lead_id) VALUES ('"+adhar_frontFileName+"','"+adhar_backFileName+"','"+driving_licenseFileName+"','"+bank_statementFileName+"','"+pan_cardFileName+"','"+otherFileName+"','"+res.insertId+"')",function(err,res){
                        if(!err){
                            response = {
                                'status':'success',
                                "message":"files uploaded successfully."
                            }
                            resolve(response);
                        }
                        else{
                            response = {
                                'status': 'error',
                                'message': err,
                            }
                        }
                        resolve(response);
                    });

                }

            })
            }else{
                response={
                    "status":'error',
                    "message":"Driving license is required."
                }
                manageLeadData(res.insertId);
                resolve(response);
            }

            response = {
                'status':'success',
                "message":"Lead data inserted successfully",
            }

        }
        else{
            response = {
                'status': 'error',
                'message': err,
            }
        }
        resolve(response)
    });
}
else{
    response = {
        'status': 'TokenExpiredError',
        'message': 'Token expired',
    }
    resolve(response)
}
});
});
}

user.applyLoan=async function(authorization,body){

    return new Promise((resolve) => {

        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }

        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
               var user_id  = jwt.decode(token, 'secret').user_id;
               var loan_id  = 'SL'+ Math.floor(Math.random() * 900000);
               var loan_status  = 3;

               sql.query("INSERT INTO loan_applications (loan_amount,loan_duration,loan_type,loan_status,user_id,loan_id) VALUES ('"+body.loan_amount+"','"+body.loan_duration+"','"+body.loan_type+"','"+loan_status+"','"+user_id+"','"+loan_id+"')",function(err,res){
                if(!err){

                    response = {
                        'status':'success',
                        "message":"Loan data inserted successfully",
                        "loan_id":res.insertId
                    }
                    
                }
                else{
                    response = {
                        'status': 'error',
                        'message': err,
                    }
                }
                resolve(response)
            });
           }
           else{
            response = {
                'status': 'TokenExpiredError',
                'message': 'Token expired',
            }
            resolve(response)
        }
    });
    });
}

user.checkToken=async function(authorization){
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var user_id  = jwt.decode(token, 'secret').user_id;
                sql.query("SELECT * from users  WHERE id='"+user_id+"'",function(errs,res){
                    if(res[0].is_active == 1 && res[0].is_verified == 1 && res[0].is_deleted == 0){

                        response = {
                            'status': 'success',
                            'message': 'Token matched',
                        }
                        resolve(response)
                    }
                    else{

                        response = {
                            'status': 'TokenExpiredError',
                            'message': 'Token expired',
                        }
                        resolve(response)
                    }
                })
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }
        });
    });
}



user.get_cms = async function(authorization,body) {
    return new Promise((resolve) => {

        sql.query("SELECT * from cms_pages  WHERE unique_key='"+body.unique_key+"'",function(errs,res){
            if(!errs){
                if(res[0]){    
                    response = {
                        'status':'success',
                        data:res[0],
                    }
                }
                else {                                    
                    response = {
                        'status': 'success',
                        'message': 'cms pages not found',
                    }                                        
                }
            }
            else {
                response = {
                    'status': 'error',
                    'message': errs,
                }
            }
            resolve(response)
        });

    });
} 

user.get_profile = async function(authorization,id) {

    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {

            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;

                sql.query("SELECT user_addresses.*,users.first_name, users.last_name ,users.email, users.phone_number, user_details.* from user_addresses  INNER JOIN users ON (user_addresses.user_id = users.id) INNER JOIN user_details ON (user_details.user_id = users.id) WHERE user_addresses.user_id='"+user_id+"'",function(errs,res){
                    if(!errs){

                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                            resolve(response)
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                'message': 'notification not found',
                            } 
                            resolve(response)                                       
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 
user.get_notification = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;

                var offset = (body.query.page - 1) * body.query.page_size;

                sql.query("SELECT * from notifications  WHERE user_id='"+user_id+"' ORDER BY id DESC LIMIT "+ offset +','+  body.query.page_size,function(errs,res){

                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                            resolve(response)
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                'message': 'notification not found',
                                data:res,
                            } 
                            resolve(response)                                       
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 


user.assigned_lead_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;
                var offset = (body.query.page - 1) * body.query.page_size;
                var search_text = body.query.search ? body.query.search : null ;
                if(search_text == null){
                    var sql1="SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+1+"' AND partner_id='"+user_id+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                else{
                    var sql1 = "SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+1+"' AND partner_id='"+user_id+"' AND  leads.user_details LIKE '%"+search_text+"%' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                //if(body.query.search)
                sql.query(sql1,function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.active_lead_list = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;
                var offset = (body.query.page - 1) * body.query.page_size;
                var search_text = body.query.search ? body.query.search : null ;
                if(search_text == null){
                    var sql1="SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+0+"' AND partner_id='"+user_id+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                else{
                    var sql1 = "SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+0+"' AND partner_id='"+user_id+"' AND  leads.user_details LIKE '%"+search_text+"%' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                //if(body.query.search)
                sql.query(sql1,function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.active_lead_list_filter = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;
                var offset = (body.query.page - 1) * body.query.page_size;
                var search_text = body.query.search ? body.query.search : null ;
                if(search_text == null){
                    var sql1="SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+0+"' AND partner_id='"+user_id+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                else{
                    var sql1 = "SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+0+"' AND partner_id='"+user_id+"' AND  leads.status ='"+search_text+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                //if(body.query.search)
                sql.query(sql1,function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.assigned_lead_list_filter = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;
                var offset = (body.query.page - 1) * body.query.page_size;
                var search_text = body.query.search ? body.query.search : null ;
                if(search_text == null){
                    var sql1="SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+1+"' AND partner_id='"+user_id+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                else{
                    var sql1 = "SELECT leads.* , leads_document.*, loans_management.*,loans_management.status AS loans_management_status,leads.status AS leads_status from leads  INNER JOIN leads_document ON leads.id = leads_document.lead_id INNER JOIN loans_management ON leads.loan_type = loans_management.id WHERE added_by='"+1+"' AND partner_id='"+user_id+"' AND  leads.status ='"+search_text+"' ORDER BY leads.id DESC LIMIT "+ offset +','+  body.query.page_size
                }
                //if(body.query.search)
                sql.query(sql1,function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.get_active_lead_data = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        var active = 0;
        var completed = 0;
        var in_progress = 0;
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var user_id  = jwt.decode(token, 'secret').user_id;
                sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+2+"' AND added_by='"+0+"'",function(errs,res){
                    if(!errs){
                        active= res.length
                        sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+0+"' AND added_by='"+0+"'",function(errs1,res1){
                            in_progress= res1.length
                        })
                        sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+1+"' AND added_by='"+0+"'",function(errs2,res2){
                            completed= res2.length
                        })
                        response = {
                            'status':'success',
                            data:{"active" :active,"in_progress" :in_progress,"completed" :completed,},
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.get_assigned_lead_data = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        var active = 0;
        var completed = 0;
        var in_progress = 0;
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var user_id  = jwt.decode(token, 'secret').user_id;
                sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+2+"' AND added_by='"+1+"'",function(errs,res){
                    if(!errs){
                        active= res.length
                        sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+0+"' AND added_by='"+1+"'",function(errs1,res1){
                            in_progress= res1.length
                        })
                        sql.query("SELECT * from leads WHERE partner_id='"+user_id+"' AND status='"+1+"' AND added_by='"+1+"'",function(errs2,res2){
                            completed= res2.length
                        })
                        response = {
                            'status':'success',
                            data:{"active" :active,"in_progress" :in_progress,"completed" :completed,},
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}


//Get loan list
user.listLoan = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;
                var offset = (body.query.page - 1) * body.query.page_size;
                sql.query("SELECT loan_applications.* from loan_applications  INNER JOIN users ON loan_applications.user_id = users.id WHERE user_id='"+user_id+"' ORDER BY id DESC LIMIT "+ offset +','+  body.query.page_size,function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Get loan Management
user.loanManagement = async function() {
    return new Promise((resolve) => {
       /* if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){*/

               // var user_id  = jwt.decode(token, 'secret').user_id;

               sql.query("SELECT * from loans_management WHERE status = '1'",function(errs,res){
                if(!errs){
                    if(res[0]){    
                        response = {
                            'status':'success',
                            data:res,
                        }
                    }
                    else {                                    
                        response = {
                            'status': 'success',
                            data:res,
                            'message': 'Loan management not found',
                        }                                        
                    }
                }
                else{
                    response = {
                        'status': 'error',
                        'message': errs,
                    }
                }
                resolve(response)
            });
           /* }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); */
    });
} 

user.update_profile = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }

        jwt.verify(token, 'secret', function(err, decoded) {

            if(!err){
                var user_id  = jwt.decode(token, 'secret').user_id;

                var dob =  moment(new Date(body.date_of_birth)).format('YYYY-MM-DD');
                
                if(body.aadhar_card && body.aadhar_card != '' ){
                    var adhar_card = body.aadhar_card;
                }else{
                    var adhar_card = null;
                }


                if(body.email && body.email != '' ){
                    var email = body.email;
                }else{
                    var email = null;
                }

                var new_adhar_card = adhar_card == null ? null : "'"+adhar_card+"'";
                var new_email = email == null ? null : "'"+email+"'";

                sql.query("UPDATE users SET email="+new_email+" ,first_name='"+body.first_name+"',last_name='"+body.last_name+"' WHERE id='"+user_id+"'",function(err,res){
                    if(!err){
                        sql.query("UPDATE user_addresses SET latitude='"+body.latitude+"',longitude='"+body.longitude+"',address='"+body.address+"',city='"+body.city+"',country='"+body.country+"',state='"+body.state+"' WHERE user_id='"+user_id+"'",function(err,res){
                            if(!err){

                                sql.query("UPDATE user_details SET aadhar_card= "+new_adhar_card+" , date_of_birth='"+dob+"' WHERE user_id='"+user_id+"'",function(err,res){
                                    if(!err){
                                        response = {
                                            'status':'success',
                                            'message':"Profile updated successfully",
                                        }
                                        resolve(response)
                                    }else {                                    
                                        response = {
                                            'status': 'fail',
                                            'message': err,
                                        }                                        
                                        resolve(response)
                                    }
                                });    
                                
                            }
                            else {                                    
                                response = {
                                    'status': 'fail',
                                    'message': err,
                                }                                        
                                resolve(response)
                            }
                        });    
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': err,
                        }
                        resolve(response)
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 



user.set_language = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                var user_id  = jwt.decode(token, 'secret').user_id;

                sql.query("SELECT * from user_details WHERE user_id='"+user_id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){ 
                            sql.query("UPDATE user_details SET language='"+body.language+"' WHERE user_id='"+user_id+"'",function(err,res){
                             if(res){    
                                response = {
                                    'status':'success',
                                    'message':'Language updated successfully',
                                }
                                resolve(response)
                            }
                        });   
                        }
                        else { 
                            sql.query("INSERT INTO user_details( user_id,language ) VALUES('"+ user_id +"','"+ body.language +"')",function(errs,res){
                                if(!errs){
                                    response = {
                                        'status': 'success',
                                        'message': "Language set successfully",

                                    }
                                    resolve(response)
                                }else{
                                    response = {
                                        'status': 'error',
                                        'message': errs,
                                    }
                                    resolve(response)
                                }
                                
                            });
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                        resolve(response)
                    }
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}

user.get_language = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var user_id  = jwt.decode(token, 'secret').user_id;
                sql.query("SELECT * from user_details WHERE user_id='"+user_id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res,
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'success',
                                data:res,
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
}
//Get user function
user.get_user = async function(authorization,id) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){

                sql.query("SELECT * from users WHERE id='"+id+"'",function(errs,res){
                    if(!errs){
                        if(res[0]){    
                            response = {
                                'status':'success',
                                data:res[0],
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Update user function
user.update_user = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                var createdDate = userDefinedFunction.databaseFormat();
                sql.query("UPDATE users SET full_name='"+body.username+"', email='"+body.email+"',phone_number='"+body.phone_number+"',updated_at='"+createdDate+"' WHERE id='"+body.id+"'",function(err,res){
                    if(!err){
                        if(res){    
                            response = {
                                'status':'success',
                                'message':'Successfully updated the user',
                            }
                        }
                        else {                                    
                            response = {
                                'status': 'fail',
                                'message': 'user not found',
                            }                                        
                        }
                    }
                    else{
                        response = {
                            'status': 'error',
                            'message': errs,
                        }
                    }
                    resolve(response)
                });
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

//Change password function
user.change_password = async function(authorization,body) {
    const newpasswordHash = await generatePassword(body.new_password);
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        //console.log(token)
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                bcrypt.compare(body.old_password, body.curr_password, function(errs, ress) {
                    if(!errs){                    
                        if(ress==true){  
                            sql.query("UPDATE users SET password='"+newpasswordHash+"' WHERE id='"+body.id+"'",function(errss,res){
                                if(!errss){
                                    response = {
                                        'status':'success',
                                        'message':'Successfully updated the passwod',
                                    }
                                }
                                else{
                                    response = {
                                        'status': 'error',
                                        'message': errss,
                                    }
                                }
                                resolve(response)
                            });      
                        }
                        else{
                            response = {
                                'status':'mismatch',
                                'message':'Old password didnt match',
                                data:ress
                            }
                            resolve(response)
                        }
                    }
                    else{
                        response = {
                            'status':'fail',
                            'message':'Fail to check password',
                        }
                        resolve(response)
                    }

                }); 
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 




//check password function
user.check_password = async function(authorization,body) {
    return new Promise((resolve) => {
        if (authorization && authorization.startsWith('Bearer')) {
            token = authorization.slice(7, authorization.length);
        }
        else{
            token='';
        }
        jwt.verify(token, 'secret', function(err, decoded) {
            if(!err){
                bcrypt.compare(body.password, body.curr_password, function(errs, ress) {

                    if(!errs){             
                        if(ress==true){
                            response = {
                                'status':'success'
                            }
                            resolve(response)
                        }
                        else{
                            response = {
                                'status':'mismatch',
                                'message':'Incorrect Password',
                                data:ress
                            }
                            resolve(response)
                        }
                    }
                    else{
                        response = {
                            'status':'fail',
                            'message':'Failed to check password',
                        }
                        resolve(response)
                    }
                }); 
            }
            else{
                response = {
                    'status': 'TokenExpiredError',
                    'message': 'Token expired',
                }
                resolve(response)
            }            
        }); 
    });
} 

module.exports= user;